<script lang="ts">
    import type { Repository } from "$lib/types/githubResults.type";
    import DataTable, {
        Body,
        Cell,
        Head,
        Label,
        Row,
        SortValue,
    } from "@smui/data-table";
    import IconButton from "@smui/icon-button";

    const sources = [
        { name: "Zenodo", key: "zenodo" },
        { name: "OpenAlex", key: "openAlex" },
        { name: "OpenCitation", key: "openCitation" },
        { name: "DataCite", key: "DataCite" },
        { name: "CitationCff", key: "citationCff" },
        { name: "Total Citations", key: "total" },
    ];

    export let repositories: Repository[];
    let items = [...repositories];

    let sort: string = "";
    let sortDirection: Lowercase<keyof typeof SortValue> = "ascending";

    $: {
        repositories;
        handleSort();
    }
    function handleSort() {
        items = [...repositories].sort((a, b) => {
            const [aVal, bVal] = [
                a.amountPublications.get(sort) ?? 0,
                b.amountPublications.get(sort) ?? 0,
            ][sortDirection === "ascending" ? "slice" : "reverse"]();
            return aVal - bVal;
        });
    }
</script>

<DataTable
    sortable
    stickyHeader
    bind:sort
    bind:sortDirection
    on:SMUIDataTable:sorted={handleSort}
    table$aria-label="Repositories list"
    class="w-full"
>
    <Head>
        <Row>
            <Cell sortable={false}>
                Repository Name (Click to show Details)
            </Cell>
            {#each sources as source}
                <Cell numeric columnId={source.key}>
                    <IconButton class="material-icons">arrow_downward</IconButton>
                    <Label>{source.name}</Label>
                </Cell>
            {/each}
            <Cell sortable={false}>Language (Select)</Cell>
        </Row>
    </Head>
    <Body>
        {#each items as repository}
            <Row>
                <Cell>{repository.name}</Cell>
                {#each sources as source}
                    <Cell numeric>
                        {repository.amountPublications.get(source.key) ?? 0}
                    </Cell>
                {/each}
                <Cell>{repository.language}</Cell>
            </Row>
        {/each}
    </Body>
</DataTable>
